VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "KeyCollection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements IEnumerable
Implements ICollection
Implements IReadOnlyCollection

Private m_Data As ICollection

Friend Sub Init(ByVal Items As ICollection)
    Set m_Data = Items
End Sub

Public Sub CopyTo(ArrayTo As Variant, Optional ByVal Index As Long)
    Call m_Data.CopyTo(ArrayTo, Index)
End Sub

Public Property Get Count() As Long
    Count = m_Data.Count
End Property

Public Function GetEnumerator() As IEnumerator
Attribute GetEnumerator.VB_UserMemId = -4
    Set GetEnumerator = m_Data.GetEnumerator
End Function

Private Sub ICollection_Add(Item As Variant)
    Error 0
End Sub

Private Sub ICollection_Clear()
    Error 0
End Sub

Private Function ICollection_Contains(Item As Variant) As Boolean
    ICollection_Contains = m_Data.Contains(Item)
End Function

Private Property Get ICollection_IsReadOnly() As Boolean
    ICollection_IsReadOnly = True
End Property

Private Function ICollection_Remove(Value As Variant) As Boolean
    Error 0
End Function

Private Sub ICollection_CopyTo(ArrayTo As Variant, Optional ByVal Index As Long)
    Call Me.CopyTo(ArrayTo, Index)
End Sub

Private Property Get ICollection_Count() As Long
    ICollection_Count = Me.Count
End Property

Private Function ICollection_GetEnumerator() As IEnumerator
    Set ICollection_GetEnumerator = Me.GetEnumerator
End Function

Private Function IEnumerable_GetEnumerator() As IEnumerator
    Set IEnumerable_GetEnumerator = Me.GetEnumerator
End Function

Private Property Get IReadOnlyCollection_Count() As Long
    IReadOnlyCollection_Count = Me.Count
End Property

Private Function IReadOnlyCollection_GetEnumerator() As XDSystemLib.IEnumerator
    Set IReadOnlyCollection_GetEnumerator = Me.GetEnumerator
End Function
