VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ReadOnlyDictionary"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements IReadOnlyCollection
Implements IDictionary
Implements IEnumerable

Private m_Data As IDictionary

'Public Function Key(ByVal Index As Long) As String
'    Key = m_Data.Keys.Item(Index).Name
'End Function

Public Sub Init(ByVal data As IDictionary)
    If m_Data Is Nothing = False Then Call Err.Raise(vbObjectError, , "Dictionary already filled")

    Set m_Data = data
End Sub

'Subs
Public Sub CopyTo(arrayTo As Variant, ByVal index As Long)
    Call m_Data.CopyTo(arrayTo, index)
End Sub

'Functions
Public Function Contains(ByVal Key As String) As Boolean
    Contains = m_Data.ContainsKey(Key)
End Function

'Public Function Equals(ByVal Obj As Object) As Boolean
'End Function

'Public Function Equals(ByVal ObjA As Object, ByVal ObjB As Object) As Boolean
'End Function

Public Function GetEnumerator() As IEnumerator
Attribute GetEnumerator.VB_UserMemId = -4
    Dim Enumerable As IEnumerable
    
    Set Enumerable = m_Data

    Set GetEnumerator = Enumerable.GetEnumerator
End Function

'Public Function IndexOf(Value As Variant) As Long
'    IndexOf = m_Data.IndexOf(Value)
'End Function

'Public Function ReferenceEquals(ByVal ObjA As Object, ByVal ObjB As Object) As Boolean
'End Function

'Public Function ToString() As String
'End Function

'Properties
Public Property Get Count() As Long
    Count = m_Data.Count
End Property

Public Property Get Keys() As IReadOnlyCollection
    Set Keys = m_Data.Keys
End Property

Public Property Get Item(ByVal Key As String) As Variant
Attribute Item.VB_UserMemId = 0
    Call SwapVar(Item, m_Data.Item(Key))
End Property

Private Sub IDictionary_Add(ByVal Key As Variant, Value As Variant)
    Error 0
End Sub

Private Function IDictionary_ContainsKey(ByVal Key As Variant) As Boolean
    IDictionary_ContainsKey = Me.Contains(Key)
End Function

Private Sub IDictionary_CopyTo(arrayTo As Variant, Optional ByVal index As Long)
    Call Me.CopyTo(arrayTo, index)
End Sub

Private Property Get IDictionary_Count() As Long
    IDictionary_Count = Me.Count
End Property

Private Function IDictionary_GetEnumerator() As IDictionaryEnumerator
    Set IDictionary_GetEnumerator = m_Data.GetEnumerator
End Function

Private Property Get IDictionary_IsFixedSize() As Boolean
    IDictionary_IsFixedSize = True
End Property

Private Property Get IDictionary_IsReadOnly() As Boolean
    IDictionary_IsReadOnly = True
End Property

Private Property Set IDictionary_Item(ByVal index As Variant, ByVal RHS As Object)
    Error 0
End Property

Private Property Let IDictionary_Item(ByVal index As Variant, ByVal RHS As Variant)
    Error 0
End Property

Private Property Get IDictionary_Item(ByVal index As Variant) As Variant
    Call SwapVar(IDictionary_Item, m_Data.Item(index))
End Property

Private Property Get IDictionary_Keys() As IReadOnlyCollection
    Set IDictionary_Keys = m_Data.Keys
End Property

Private Sub IDictionary_Remove(ByVal Key As Variant)
    Error 0
End Sub

Public Function TryGetValue(ByVal Key As String, Value As Variant) As Boolean
    TryGetValue = m_Data.TryGetValue(Key, Value)
End Function

Private Function IDictionary_TryGetValue(ByVal Key As Variant, Value As Variant) As Boolean
    IDictionary_TryGetValue = m_Data.TryGetValue(Key, Value)
End Function

Private Property Get IDictionary_Values() As IReadOnlyCollection
    Set IDictionary_Values = m_Data.Values
End Property

Private Function IEnumerable_GetEnumerator() As IEnumerator
    Set IEnumerable_GetEnumerator = Me.GetEnumerator
End Function

Private Sub IDictionary_Clear()
    Error 0
End Sub

Private Sub IReadOnlyCollection_CopyTo(arrayTo As Variant, Optional ByVal index As Long)
    Call Me.CopyTo(arrayTo, index)
End Sub

Private Property Get IReadOnlyCollection_Count() As Long
    IReadOnlyCollection_Count = Me.Count
End Property

Private Function IReadOnlyCollection_GetEnumerator() As IEnumerator
    Set IReadOnlyCollection_GetEnumerator = Me.GetEnumerator
End Function

