VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Conversion"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Enum WeekdayConversion
    UsToGerman
    GermanToUs
End Enum

Private Type myBytes
    B1 As Byte
    B2 As Byte
    B3 As Byte
    B4 As Byte
End Type

Private Type myLong
    Val As Long
End Type

'Public Enum LanguageId
'    LANG_NEUTRAL = &H0
'    SUBLANG_NEUTRAL = &H0            ' language neutral
'    SUBLANG_DEFAULT = &H1             ' user default
'    SUBLANG_SYS_DEFAULT = &H2    ' system default
'
'    SORT_DEFAULT = &H0 ' sorting default
'
'    LANG_SYSTEM_DEFAULT = &H800
'    LANG_USER_DEFAULT = &H400
'
'    LOCALE_SYSTEM_DEFAULT = LANG_SYSTEM_DEFAULT
'    LOCALE_USER_DEFAULT = LANG_USER_DEFAULT
'End Enum
'
'Public Function MAKELANGID(ByVal usPrimaryLanguage As Long, ByVal usSubLanguage As Long) As Long
'    MAKELANGID = ShiftBitsDWORD(LOWORD(usSubLanguage), 10, True) Or LOWORD(usPrimaryLanguage)
'End Function
'
'Public Function MAKELCID(ByVal wLanguageId As Long, ByVal wSortId As Long) As Long
'    MAKELCID = ShiftBitsDWORD(LOWORD(wSortId), 16, True) Or LOWORD(wLanguageId)
'End Function
'
'Private Function ShiftBitsDWORD(ByVal dwTarget As Long, ByVal bBits As Byte, ByVal fShiftLeft As Boolean) As Long
'    On Error GoTo Out:
'
'    If fShiftLeft Then
'        ShiftBitsDWORD = dwTarget * (2 ^ bBits)
'    Else
'        ShiftBitsDWORD = dwTarget * (2 ^ -bBits)
'    End If
'Out:
'End Function
'
'Private Function HIWORD(ByVal dwValue As Long) As Integer
'    Call RtlMoveMemory(HIWORD, ByVal VarPtr(dwValue) + 2, 2)
'End Function
'
'Private Function LOWORD(ByVal dwValue As Long) As Integer
'    Call RtlMoveMemory(LOWORD, dwValue, 2)
'End Function

Public Function GetObjFromPtr(ByVal Ptr As Long) As Object
    Dim nObj As Object
    
    If Ptr <> 0 Then
        Call RtlMoveMemory(nObj, Ptr, 4)
        
        Set GetObjFromPtr = nObj
        
        Call RtlMoveMemory(nObj, 0&, 4)
    End If
End Function

Public Sub SwapVar(ByRef VarA As Variant, ByRef VarB As Variant)
    Call mdlArray.SwapVar(VarA, VarB)
End Sub

'Public Function CloneFont(ByVal Font As IFont) As StdFont
'    Call Font.Clone(CloneFont)
'End Function

Public Sub SetVariantVarType(ByRef var As Variant, ByVal VarType As VbVarType)
    Call RtlMoveMemory(var, VarType, 1)
End Sub

Public Sub SetVariantReferencePtr(ByRef var As Variant, ByVal Ptr As Long)
    Call RtlMoveMemory(VarPtr(var) + 8, Ptr, 4)
End Sub

Public Function ConvertTextToNumber( _
        ByVal Text As String, _
        Optional ByVal SpecialChars As String = " .,_", _
        Optional ByVal BitsPerChar As Byte = 5 _
        ) As Variant
    ConvertTextToNumber = mdlFunctions.GetNumberFromText(Text, SpecialChars, BitsPerChar)
End Function

Public Function ConvertNumberToText( _
        ByVal Number As Variant, _
        Optional ByVal SpecialChars As String = " .,_", _
        Optional ByVal BitsPerChar As Byte = 5 _
        ) As String
    ConvertNumberToText = mdlFunctions.GetTextFromNumber(Number, SpecialChars, BitsPerChar)
End Function

Public Sub SetVariantInfo(ByRef var As Variant, ByRef VariantInfo As VariantInfo)
    Call RtlMoveMemory(var, VariantInfo, 16)
End Sub

Public Function GetVariantInfo(ByRef var As Variant) As VariantInfo
    Call RtlMoveMemory(GetVariantInfo, var, 16)
End Function

Public Function ConvertIPToLong(ByVal IP As String, Optional ByVal Unsigned As Boolean) As Variant
    Dim parse() As String
    Dim b As myBytes
    Dim l As myLong

    parse = Split(IP, ".")

    b.B1 = Val(parse(3))
    b.B2 = Val(parse(2))
    b.B3 = Val(parse(1))
    b.B4 = Val(parse(0))

    LSet l = b

    ConvertIPToLong = l.Val
    
    If Unsigned Then 'IPToLong < 0 And
        Call RtlMoveMemory(ConvertIPToLong, VarEnum.VT_UI4, 1)
    End If
End Function

'Set X = New Conversion: X.ConvertLongToIP (X.ConvertIPToLong("255.255.255.255", True))
Public Function ConvertLongToIP(ByVal Number As Long) As String
    Dim l As myLong
    Dim b As myBytes

    l.Val = Number

    LSet b = l

    ConvertLongToIP = CStr(b.B4) + "." & CStr(b.B3) + "." & CStr(b.B2) & "." & CStr(b.B1)
End Function

Public Function BinToHex(ByRef Value As Variant) As String
    Dim arrBytes() As Byte
    Dim i As Long
    Dim Ptr As Long
    Dim b As Byte
    
'    Debug.Assert 0
    
    If VarType(Value) = (vbArray Or vbByte) Then
        If ApiBound(Value) > 0 Then
            Dim FromType As Integer
            
            Call RtlMoveMemory(FromType, Value, 2)
            
            If (FromType And VT_BYREF) > 0 Then
                Call RtlMoveMemory(Ptr, ByVal VarPtr(Value) + 8, 4)
                
                Call RtlMoveMemory(ByVal VarPtrArray(arrBytes), ByVal Ptr, 4)
            Else
                Call RtlMoveMemory(ByVal VarPtrArray(arrBytes), ByVal VarPtr(Value) + 8, 4)
            End If

            BinToHex = String$((UBound(arrBytes, 1) + 1) * 2 + 2, "0")

            Mid$(BinToHex, 1, 2) = "0x"
    
            For i = 0 To UBound(arrBytes)
                Select Case arrBytes(i)
                    Case 0
                    Case Is < 16
                        Mid$(BinToHex, i * 2 + 2 + 2, 1) = Hex$(arrBytes(i))
                    Case Else
                        Mid$(BinToHex, i * 2 + 1 + 2, 2) = Hex$(arrBytes(i))
                End Select
            Next
            
            Call RtlMoveMemory(ByVal VarPtrArray(arrBytes), 0&, 4)
        End If
    ElseIf VarType(Value) = vbString Then
        If LenB(Value) = 0 Then Exit Function
        
        BinToHex = String$(LenB(Value), "0")
        
        Ptr = StrPtr(Value)
        
        For i = 0 To Len(Value) - 1
            Call RtlMoveMemory(b, ByVal Ptr + (i * 2), 1)

            Select Case b
                Case 0
                Case Is < 16
                    Mid$(BinToHex, i * 2 + 2, 1) = Hex$(b)
                Case Else
                    Mid$(BinToHex, i * 2 + 1, 2) = Hex$(b)
            End Select
        Next
    Else
        Error 0
    End If
End Function

Public Function CVal(ByVal Text As String) As Double
    Dim i As Long
    
    i = 1
    
    For i = 1 To Len(Text)
        If Not IsNumeric(Mid$(Text, i, 1)) And Not Mid$(Text, i, 1) = "," And Not Mid$(Text, i, 1) = "." Then
            Exit For
        End If
    Next i
    
    i = i - 1
    
    If i > 0 Then
        CVal = CDbl(Left$(Text, i))
    End If
End Function

Public Function CWeekday(ByVal Day As VbDayOfWeek, Optional ByVal ConvertMethod As WeekdayConversion = UsToGerman) As Long
    Select Case ConvertMethod
        Case WeekdayConversion.UsToGerman
            If Day = vbSunday Then
                CWeekday = 7
            ElseIf Day <= 7 And Day > 1 Then
                CWeekday = Day - 1
            End If
        Case WeekdayConversion.GermanToUs
            If Day = 7 Then
                CWeekday = 1
            ElseIf Day < 7 And Day > 0 Then
                CWeekday = Day + 1
            End If
    End Select
End Function

Public Function CTryDate(ByVal Value As Variant) As Date
    CTryDate = mdlDate.ApiCTryDate(Value)
End Function

Public Function CDateOfThisYear(ByVal DateValue As Date) As Date
    CDateOfThisYear = DateSerial(Year(Date), month(DateValue), Day(DateValue))
End Function

Public Function CDbDate(ByVal DateValue As Variant, Optional ByVal TruncateTime As Boolean) As String
    DateValue = CDate(DateValue)

    If (DateValue - Int(DateValue)) > 0 And Not TruncateTime Then
        CDbDate = "#" & month(DateValue) & "/" & Day(DateValue) & "/" & Year(DateValue) & " " & Hour(DateValue) & ":" & Minute(DateValue) & ":" & Second(DateValue) & "#"
    Else
        CDbDate = "#" & month(DateValue) & "/" & Day(DateValue) & "/" & Year(DateValue) & "#"
    End If
End Function

Public Function CTryCur(ByVal Text As String) As Currency
    If IsNumeric(Text) Then
        CTryCur = CCur(Text)
    End If
End Function

Public Function CTrySng(ByVal Text As String) As Single
    If IsNumeric(Text) Then
        CTrySng = CSng(Text)
    End If
End Function

Public Function CTryDbl(ByVal Text As String) As Double
    If IsNumeric(Text) Then
        CTryDbl = CDbl(Text)
    End If
End Function

Public Function CTryLng(ByVal Text As String) As Long
    If IsNumeric(Text) Then
        CTryLng = CLng(Text)
    End If
End Function

Public Static Function CRoman( _
        ByVal Number As Integer) As String
    Static R As Variant
    Static N As Variant
    Dim i As Long
    
    If Number = 0 Then
        CRoman = "Nicht angegeben"
    
        Exit Function
    End If
    
    If IsEmpty(R) Then
        R = Array("M", "CM", "D", "CD", "C", "XC", "L", "XL", "X", "IX", "V", "IV", "I")
        N = Array(1000, 900, 500, 400, 100, 90, 50, 40, 10, 9, 5, 4, 1)
    End If
    
    For i = LBound(R) To UBound(R)
        Do Until N(i) > Number
            CRoman = CRoman & R(i)
            Number = Number - N(i)
        Loop
    Next i
End Function

