Attribute VB_Name = "mdlWindows"
Option Explicit
Private Const WS_BORDER As Long = &H800000

'Private Declare Function GetThemeAppProperties Lib "uxtheme.dll" () As Long
'Private Declare Function EnableTheming Lib "uxtheme.dll" (ByVal B As Boolean) As Long
'
'Private Declare Function DrawThemeBackground Lib "uxtheme.dll" ( _
'   ByVal hTheme As Long, _
'   ByVal Hdc As Long, _
'   ByVal iPartID As Long, _
'   ByVal iStateID As Long, _
'   pRect As RECT, _
'   pClipRect As RECT) As Long
'
'Private Declare Function DrawThemeText Lib "uxtheme.dll" ( _
'   ByVal hTheme As Long, _
'   ByVal Hdc As Long, _
'   ByVal iPartID As Long, _
'   ByVal iStateID As Long, _
'   ByVal pszText As Long, _
'   ByVal iCharCount As Long, _
'   ByVal dwTextFlags As Long, _
'   ByVal dwTextFlags2 As Long, _
'   pRect As RECT) As Long
'
'Private Declare Function DrawThemeEdge Lib "uxtheme.dll" ( _
'   ByVal hTheme As Long, _
'   ByVal Hdc As Long, _
'   ByVal iPartID As Long, _
'   ByVal iStateID As Long, _
'   pDestRect As RECT, _
'   ByVal uEdge As Long, _
'   ByVal uFlags As Long, _
'   pContentRect As Any) As Long
'
'Private Declare Function GetThemeTextExtent Lib "uxtheme.dll" ( _
'   ByVal hTheme As Long, _
'   ByVal Hdc As Long, _
'   ByVal iPartID As Long, _
'   ByVal iStateID As Long, _
'   ByVal pszText As Long, _
'   ByVal iCharCount As Long, _
'   ByVal dwTextFlags As Long, _
'   pBoundingRect As Any, _
'   pExtentRect As RECT) As Long
'
'Private Declare Function OpenThemeData Lib "uxtheme.dll" ( _
'   ByVal hWnd As Long, _
'   ByVal pszClassList As Long) As Long
'
'Private Declare Function CloseThemeData Lib "uxtheme.dll" ( _
'   ByVal hTheme As Long) As Long
'
'Private Declare Function GetThemeSysColor Lib "uxtheme.dll" ( _
'   ByVal hTheme As Long, _
'   ByVal iColorId As Long) As Long
'
'Private Declare Function GetThemeSysSize Lib "uxtheme.dll" ( _
'   ByVal hTheme As Long, _
'   ByVal iSizeId As Long) As Long

Public Type OSVERSIONINFO
    dwOSVersionInfoSize As Long
    dwMajorVersion As Long
    dwMinorVersion As Long
    dwBuildNumber As Long
    dwPlatformId As Long
    szCSDVersion As String * 128
End Type
   
Private Declare Function SetThreadPriority Lib "kernel32.dll" ( _
    ByVal hThread As Long, _
    ByVal nPriority As Long _
) As Long

Private Declare Function SetPriorityClass Lib "kernel32.dll" ( _
    ByVal hProcess As Long, _
    ByVal dwPriorityClass As Long _
) As Long

Private Const THREAD_BASE_PRIORITY_IDLE As Long = -15&
Private Const THREAD_BASE_PRIORITY_LOWRT As Long = 15&
Private Const THREAD_BASE_PRIORITY_MIN As Long = -2&
Private Const THREAD_BASE_PRIORITY_MAX As Long = 2&

Private Declare Function GetCurrentThread Lib "kernel32.dll" () As Long

Private Declare Function GetCurrentProcess Lib "kernel32.dll" () As Long

Private Declare Function TerminateProcess Lib "kernel32" (ByVal ApphProcess As Long, ByVal ulngExitCode As Long) As Long
Private Declare Function OpenProcess Lib "kernel32" (ByVal dwDesiredAccess As Long, ByVal blnheritHandle As Long, ByVal dwAppProcessId As Long) As Long
Private Declare Function ProcessFirst Lib "kernel32" Alias "Process32First" (ByVal hSnapshot As Long, uProcess As PROCESSENTRY32) As Long
Private Declare Function ProcessNext Lib "kernel32" Alias "Process32Next" (ByVal hSnapshot As Long, uProcess As PROCESSENTRY32) As Long
Private Declare Function CreateToolhelpSnapshot Lib "kernel32" Alias "CreateToolhelp32Snapshot" (ByVal lFlags As Long, lProcessID As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long

Private Type PROCESSENTRY32
    dwSize As Long
    cntUsage As Long
    th32ProcessID As Long
    th32DefaultHeapID As Long
    th32ModuleID As Long
    cntThreads As Long
    th32ParentProcessID As Long
    pcPriClassBase As Long
    dwFlags As Long
    szExeFile As String * 260
End Type

Private Type TYPE_MEMORYSTATUS
    dwLength As Long
    dwMemoryLoad As Long
    dwTotalPhys As Long
    dwAvailPhys As Long
    dwTotalPageFile As Long
    dwAvailPageFile As Long
    dwTotalVirtual As Long
    dwAvailVirtual As Long
End Type

Private Declare Sub GlobalMemoryStatus Lib "kernel32" (lpBuffer As TYPE_MEMORYSTATUS)

Private Declare Function FormatMessage Lib "kernel32.dll" Alias _
    "FormatMessageA" (ByVal dwFlags As Long, ByRef lpSource As _
    Any, ByVal dwMessageId As Long, ByVal dwLanguageId As Long, _
    ByVal lpBuffer As String, ByVal nSize As Long, ByRef Arguments _
    As Long) As Long

Private Const FORMAT_MESSAGE_FROM_SYSTEM As Long = &H1000
Private Const FORMAT_MESSAGE_IGNORE_INSERTS As Long = &H200


Private Declare Function CreateToolhelp32Snapshot Lib _
    "kernel32.dll" (ByVal dwFlags As Long, ByVal th32ProcessID As _
    Long) As Long
'Private Declare Function CloseHandle Lib "kernel32.dll" (ByVal _
'    hObject As Long) As Long
Private Declare Function Process32First Lib "kernel32.dll" (ByVal _
    hSnapshot As Long, ByRef lppe As PROCESSENTRY32) As Long
Private Declare Function Process32Next Lib "kernel32.dll" (ByVal _
    hSnapshot As Long, ByRef lppe As PROCESSENTRY32) As Long
'Private Declare Function OpenProcess Lib "kernel32.dll" (ByVal _
'    dwDesiredAccess As Long, ByVal bInheritHandle As Long, ByVal _
'    dwProcessId As Long) As Long
Private Declare Function LocalFree Lib "kernel32.dll" (ByVal hMem _
    As Long) As Long
Private Declare Function GetSecurityInfo Lib "advapi32.dll" (ByVal _
    Handle As Long, ByVal ObjectType As SE_OBJECT_TYPE, ByVal _
    SecurityInfo As Long, ByRef ppsidOwner As Long, ByVal _
    ppsidGroup As Long, ByVal ppDacl As Long, ByVal ppSacl As _
    Long, ByRef ppSecurityDescriptor As Long) As Long
Private Declare Function LookupAccountSidW Lib "advapi32.dll" _
    (ByVal lpSystemName As Long, ByVal lpSid As Long, ByVal lpName _
    As Long, ByRef cchName As Long, ByVal lpReferencedDomainName _
    As Long, ByRef cchReferencedDomainName As Long, ByRef peUse As _
    SID_NAME_USE) As Long
Private Declare Function OpenProcessToken Lib "advapi32.dll" _
    (ByVal ProcessHandle As Long, ByVal DesiredAccess As Long, _
    TokenHandle As Long) As Long
Private Declare Function GetTokenInformation Lib "advapi32.dll" _
    (ByVal TokenHandle As Long, ByVal TokenInformationClass As _
    Long, TokenInformation As Any, ByVal TokenInformationLength As _
    Long, ReturnLength As Long) As Long

Private Const ERROR_SUCCESS As Long = 0
Private Const ERROR_INSUFFICIENT_BUFFER As Long = 122
Private Const MAX_PATH As Long = 260
Private Const TH32CS_SNAPPROCESS As Long = &H2&
Private Const READ_CONTROL As Long = &H20000
Private Const OWNER_SECURITY_INFORMATION As Long = &H1&
Private Const TOKEN_READ As Long = &H20008
Private Const SECURITY_BUILTIN_DOMAIN_RID As Long = &H20&
Private Const SECURITY_NT_AUTHORITY As Long = &H5
Private Const PROCESS_QUERY_INFORMATION As Long = 1024
Private Const PROCESS_VM_READ As Long = 16
Private Const DOMAIN_ALIAS_RID_USERS = &H221
Private Const TokenUser = 1

Private Enum SE_OBJECT_TYPE
  SE_UNKNOWN_OBJECT_TYPE = 0
  SE_FILE_OBJECT
  SE_SERVICE
  SE_PRINTER
  SE_REGISTRY_KEY
  SE_LMSHARE
  SE_KERNEL_OBJECT
  SE_WINDOW_OBJECT
  SE_DS_OBJECT
  SE_DS_OBJECT_ALL
  SE_PROVIDER_DEFINED_OBJECT
  SE_WMIGUID_OBJECT
  SE_REGISTRY_WOW64_32KEY
End Enum

Private Enum SID_NAME_USE
  SidTypeUser = 1
  SidTypeGroup
  SidTypeDomain
  SidTypeAlias
  SidTypeWellKnownGroup
  SidTypeDeletedAccount
  SidTypeInvalid
  SidTypeUnknown
  SidTypeComputer
End Enum

'Private Type PROCESSENTRY32
'  dwSize As Long
'  cntUsage As Long
'  th32ProcessID As Long
'  th32DefaultHeapID As Long
'  th32ModuleID As Long
'  cntThreads As Long
'  th32ParentProcessID As Long
'  pcPriClassBase As Long
'  dwFlags As Long
'  szExeFile As String * MAX_PATH
'End Type

'Private Type TOKEN_OWNER
'    Owner As Long
'End Type

Private Type SID_AND_ATTRIBUTES
  SID As Long
  'Pointer auf SID(0)
  Attributes As Long
End Type

Private Type TOKEN_USER
  User As SID_AND_ATTRIBUTES
  SID(500) As Byte
  'Buffer fr die SID
End Type

Const GW_HWNDFIRST = 0
Const GW_HWNDLAST = 1
Const GW_HWNDNEXT = 2
Const GW_HWNDPREV = 3
Const GW_OWNER = 4
Const GW_CHILD = 5
Const GW_MAX = 5

Const GWL_STYLE = (-16)

Const WS_VISIBLE = &H10000000
'Const WS_BORDER = &H800000

Private Declare Function GetDesktopWindow Lib "user32" () _
        As Long

Private Declare Function GetWindow Lib "user32" (ByVal hwnd _
        As Long, ByVal wCmd As Long) As Long
        
Private Declare Function GetWindowLong Lib "user32" Alias _
        "GetWindowLongA" (ByVal hwnd As Long, ByVal wIndx As _
        Long) As Long
        
Private Declare Function GetWindowTextLength Lib "user32" _
        Alias "GetWindowTextLengthA" (ByVal hwnd As Long) _
        As Long
        
Private Declare Function GetWindowText Lib "user32" Alias _
        "GetWindowTextA" (ByVal hwnd As Long, ByVal lpString _
        As String, ByVal cch As Long) As Long
               
Private Declare Function GetParent Lib "user32" (ByVal hwnd _
        As Long) As Long
        
Private Declare Function GetWindowThreadProcessId Lib "user32" _
        (ByVal hwnd As Long, lpdwProcessId As Long) As Long
Private Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long
Private Declare Function GetExitCodeProcess Lib "kernel32.dll" ( _
     ByVal hProcess As Long, _
     ByRef lpExitCode As Long) As Long
'Private Declare Function CloseHandle Lib "kernel32" (ByVal _
'        hObject As Long) As Long
        
'Private Declare Function OpenProcess Lib "kernel32" (ByVal _
'        dwDesiredAccess As Long, ByVal bInheritHandle As Long, _
'        ByVal dwProcessId As Long) As Long
        
'Private Declare Function TerminateProcess Lib "kernel32" (ByVal _
'        hProcess As Long, ByVal uExitCode As Long) As Long
Private Const STILL_ACTIVE As Long = &H103

Public Sub GetWindowInfo(ByVal hwnd&, ByRef Title As String, ByRef Task As Long)
  Dim Parent&, Result&, X&, Style&
  
    'Darstellung des Fensters
    Style = GetWindowLong(hwnd, GWL_STYLE)
    Style = Style And (WS_VISIBLE Or WS_BORDER)
            
    'Title des Fenster auslesen
    Result = GetWindowTextLength(hwnd) + 1
    Title = Space$(Result)
    Result = GetWindowText(hwnd, Title, Result)
    Title = Left$(Title, Len(Title) - 1)
    
    'In Abhngigkeit der Optionen die Ausgabe erstellen
'    If (Title <> "" Or (Check1.Value = vbChecked)) And _
'       (Style = (WS_VISIBLE Or WS_BORDER) Or Option2.Value) Then
      
      'Elternfenster ermitteln
      Parent = hwnd
      
      Do
        Parent = GetParent(Parent)
      Loop Until Parent = 0
      
      'Task Id ermitteln
      Result = GetWindowThreadProcessId(hwnd, Task)
'    End If
End Sub

Public Function GetProcessUserName(ByVal ProcessID As Long, ByRef sOwner _
    As String, ByRef sDomain As String) As Long
    
  Dim hProcessID As Long
  Dim hToken As Long
  Dim res As Long
  Dim cbBuff As Long
  Dim tiLen As Long
  Dim TU As TOKEN_USER
  Dim cnt As Long
  Dim sAcctName2 As String
  Dim cbAcctName As Long
  Dim sDomainName As String
  Dim cbDomainName As Long
  Dim peUse As Long
  Dim barr() As Byte
    
    hProcessID = OpenProcess(PROCESS_QUERY_INFORMATION Or _
        PROCESS_VM_READ, 0, ProcessID)
    If hProcessID <> 0 Then
      If OpenProcessToken(hProcessID, TOKEN_READ, hToken) = 1 Then
        res = GetTokenInformation(hToken, TokenUser, ByVal 0, _
            tiLen, cbBuff)
        If res = 0 And cbBuff > 0 Then
          tiLen = cbBuff
          If cbBuff > Len(TU) Then
            Exit Function
          End If
          res = GetTokenInformation(hToken, TokenUser, TU, tiLen, _
              cbBuff)
          If res = 1 And tiLen > 0 Then
            res = LookupAccountSidW(0, TU.User.SID, 0, cbAcctName, _
                0, cbDomainName, peUse)
            If res = 0 And Err.LastDllError = _
                ERROR_INSUFFICIENT_BUFFER Then
              sAcctName2 = Space$(cbAcctName)
              sDomainName = Space$(cbDomainName)
              res = LookupAccountSidW(0, TU.User.SID, _
                  StrPtr(sAcctName2), cbAcctName, _
                  StrPtr(sDomainName), cbDomainName, peUse)
              sOwner = Replace(Trim(sAcctName2), vbNullChar, "")
              sDomain = Replace(Trim(sDomainName), vbNullChar, "")
            Else
              'Error LookupAccountSIDW()
              GetProcessUserName = Err.LastDllError
            End If
          Else
            'Error GetTokenInformation()
            GetProcessUserName = Err.LastDllError
          End If
          'If res = 1 And ti.....
        Else
          'Error GetTokenInformation()
          GetProcessUserName = Err.LastDllError
        End If
        'If res = 0 And cb....
      Else
        'Error OpenProcessToken
        GetProcessUserName = Err.LastDllError
      End If
      'If OpenProcessToken(hPr....)
      If hToken Then
        CloseHandle hToken
      End If
      CloseHandle hProcessID
    Else
      'Error OpenProcess
      GetProcessUserName = Err.LastDllError
    End If
    'If hProcessID <> 0 Then
    
End Function

Public Function ListProcessesWithUsername() As Variant()
  Dim hSnapshot As Long
  Dim Entry As PROCESSENTRY32
  Dim FileName As String
  Dim Result As Long
  Dim hProcess As Long
  Dim pOwner As Long
  Dim pDescriptor As Long
  Dim NameBuffer As String
  Dim NameLength As Long
  Dim DomainBuffer As String
  Dim DomainLength As Long
  Dim Usage As SID_NAME_USE
  Dim Values() As Variant
  Dim i As Long
  Dim Temp(0 To 2) As Variant
    
    ' Listbox leeren
'    lb.Clear
    
    hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0)
    If hSnapshot = -1 Then
      ' Falls die Funktion fehlschlgt, abbrechen
      Exit Function
    End If
    
    Entry.dwSize = LenB(Entry)
    
    Result = Process32First(hSnapshot, Entry)
    Do While Result = 1
      FileName = Left$(Entry.szExeFile, InStr(1, Entry.szExeFile, _
          vbNullChar) - 1)
      
      Result = GetProcessUserName(Entry.th32ProcessID, NameBuffer, _
          DomainBuffer)
      If Result <> 0 Then
        NameBuffer = "ErrHandler:"
        DomainBuffer = FormatError(Result)
      End If
      
      ReDim Preserve Values(i)

      Temp(0) = FileName
      Temp(1) = NameBuffer
      Temp(2) = DomainBuffer
      
    Values(i) = Temp()
    
    i = i + 1
      
      Result = Process32Next(hSnapshot, Entry)
    Loop
    CloseHandle hSnapshot
    
    ListProcessesWithUsername = Values()
End Function

Private Function FormatError(ErrCode As Long) As String
  Dim sTemp As String
  Dim lLen As Long
    
    lLen = 256
    sTemp = String(lLen, 0)
    lLen = FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM Or _
        FORMAT_MESSAGE_IGNORE_INSERTS, ByVal 0, ErrCode, 0, sTemp, _
        lLen, ByVal 0)
    If lLen = 0 Then
      Stop
    End If
    FormatError = Left(sTemp, lLen - 2)
End Function

Public Sub FreeMemory(Optional ByVal Bytes As Long)
    Dim Phys As Long
    Dim T As TYPE_MEMORYSTATUS
    
    ' Nie mehr als 50% vom RAM freirumen
    If Bytes = 0 Then
        Call GlobalMemoryStatus(T)
    
        Phys = T.dwTotalPhys / 40
    Else
        Phys = Bytes / 20
    End If
    
    ReDim at(19) As String
    Dim i As Integer
    
    For i = 0 To 19
        at(i) = Space$(Phys \ 2)
        DoEvents
    Next i
End Sub

Public Function GetAnotherProcessID(ByVal Exename As String, ByVal ProcessID As Long) As Long
    Dim uProcess As PROCESSENTRY32
    Dim rProcessFound As Long
    Dim hSnapshot As Long
    Dim strExename As String
    Dim lngPos As Integer
    Dim lresult As Long
    
    Const PROCESS_TERMINATE = &H1
    Const TH32CS_SNAPPROCESS As Long = 2&
    
    On Error GoTo ErrHandler
    
    Exename = LCase$(Exename)
    uProcess.dwSize = Len(uProcess)
    hSnapshot = CreateToolhelpSnapshot(TH32CS_SNAPPROCESS, 0&)
    rProcessFound = ProcessFirst(hSnapshot, uProcess)
    
    Do While rProcessFound
        lngPos = InStr(1, uProcess.szExeFile, vbNullChar)
        
        strExename = LCase$(Left$(uProcess.szExeFile, lngPos - 1))
        
        If strExename = Exename Then
            GetAnotherProcessID = OpenProcess(PROCESS_TERMINATE, 0&, uProcess.th32ProcessID)
            
            If GetAnotherProcessID <> ProcessID Then
                Exit Do
            End If
        End If
        
        rProcessFound = ProcessNext(hSnapshot, uProcess)
    Loop
    
ErrHandler:
    Call CloseHandle(hSnapshot)
End Function

Public Function GetProcessID(ByVal Exename As String) As Long
    Dim uProcess As PROCESSENTRY32
    Dim rProcessFound As Long
    Dim hSnapshot As Long
    Dim strExename As String
    Dim lngPos As Integer
    Dim lresult As Long
    
    Const PROCESS_TERMINATE = &H1
    Const TH32CS_SNAPPROCESS As Long = 2&
    
    On Error GoTo ErrHandler
    
    Exename = LCase$(Exename)
    uProcess.dwSize = Len(uProcess)
    hSnapshot = CreateToolhelpSnapshot(TH32CS_SNAPPROCESS, 0&)
    rProcessFound = ProcessFirst(hSnapshot, uProcess)
    
    Do While rProcessFound
        lngPos = InStr(1, uProcess.szExeFile, vbNullChar)
        
        strExename = LCase$(Left$(uProcess.szExeFile, lngPos - 1))
        
        If strExename = Exename Then
            GetProcessID = OpenProcess(PROCESS_TERMINATE, 0&, uProcess.th32ProcessID)
            
            Exit Do
        End If
        
        rProcessFound = ProcessNext(hSnapshot, uProcess)
    Loop
    
ErrHandler:
    Call CloseHandle(hSnapshot)
End Function

Public Function TerminateProc(ByVal Exename As String, Optional ByRef ProcessID As Long) As Boolean
    Dim uProcess As PROCESSENTRY32
    Dim rProcessFound As Long
    Dim hSnapshot As Long
    Dim strExename As String
    Dim lngPos As Integer
    Dim lresult As Long
    
    Const PROCESS_TERMINATE = &H1
    Const TH32CS_SNAPPROCESS As Long = 2&
    
    On Error GoTo ErrHandler
    
    Exename = LCase$(Exename)
    uProcess.dwSize = Len(uProcess)
    hSnapshot = CreateToolhelpSnapshot(TH32CS_SNAPPROCESS, 0&)
    rProcessFound = ProcessFirst(hSnapshot, uProcess)
    
    If ProcessID Then
        lresult = TerminateProcess(ProcessID, 1&)
        TerminateProc = CloseHandle(ProcessID) = 1 And lresult = 1
    Else
        Do While rProcessFound
            lngPos = InStr(1, uProcess.szExeFile, vbNullChar)
            
            strExename = LCase$(Left$(uProcess.szExeFile, lngPos - 1))
            
            If strExename = Exename Then
                ProcessID = OpenProcess(PROCESS_TERMINATE, 0&, uProcess.th32ProcessID)
                
                lresult = TerminateProcess(ProcessID, 1&)
                TerminateProc = TerminateProc And CloseHandle(ProcessID) = 1 And lresult = 1
            Else
                If ProcessID = 0 Then
                    ProcessID = -1
                    TerminateProc = True
                End If
            End If
            
            rProcessFound = ProcessNext(hSnapshot, uProcess)
        Loop
    End If
    
ErrHandler:
    Call CloseHandle(hSnapshot)
End Function


